/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRFB                                                     */
/* Tabela : PRODFABRIC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRFB' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRFB
GO

CREATE TRIGGER DTULTATU_PRFB
ON PRODFABRIC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODFABRIC', null, 'CDPRODUTO='+ CDPRODUTO+ ';'+
                                         'CDFABRIC=' + CDFABRIC + ';' +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODFABRIC
      SET DTULTATUPRFB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRODFABRIC.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(PRODFABRIC.CDFABRIC,0)  = ISNULL(INSERTED.CDFABRIC,0));
   END;
END;
GO

