function crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um motivo de evolução
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo da evolução.
    */
    this.saveNewActivityProfileEvolutionReason = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileEvolutionReason= currentRow.MOTIVOS;
        var rows = [];
        
        activityProfileEvolutionReason.forEach(function(reason, reasonIndex){
            
            rows.push(this.setActivityProfileReasonValuesInCurrentRow(widget, reasonIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfimotievo_motievolcont/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this)).catch(function() {
            ScreenService.showMessage('Ocorreu um erro e não foi possível realizar o procedimento.<br>Contate um administrador.');
        });
    };
    
    /**
     * Função para pegar as informações do 
     * array de motivos na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo do evolução.
     * 
     * @param {int} reasonIndex index do motivo
     * no array de motivos presente na currentRow.
    */
    this.setActivityProfileReasonValuesInCurrentRow = function(widget, reasonIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.CDMOTIEVOCON= currentRow.MOTIVOS[reasonIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de motivos de evolução e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de motivos.
    */
    this.insertEvolutionReasonFilter = function(widget){
        
        var reasonField = widget.getField("MOTIVOS");
        var reasonFieldFilter = reasonField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(reasonFieldFilter, "P_NRSEQPERFATIV");
        
        reasonFieldFilter[nrseqperfativIndex].value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        
        reasonField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller', crm00001002_Motivo_Evolucao_Perfil_Atividade_Controller);
});